VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00E0E0E0&
   ClientHeight    =   5670
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8520
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9.75
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   378
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   568
   StartUpPosition =   2  'CenterScreen
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   240
      Max             =   100
      TabIndex        =   0
      Top             =   180
      Width           =   2715
   End
   Begin VB.Label Label1 
      Height          =   255
      Left            =   3060
      TabIndex        =   1
      Top             =   180
      Width           =   4035
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Vector
  x As Single
  y As Single
End Type

Dim v(255) As Vector, vCnt As Long, Sharpness As Single

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button = 1 Then
    If vCnt > 255 Then vCnt = 0
    v(vCnt) = V2Create(x, y)
    vCnt = vCnt + 1
  ElseIf Button = 2 Then
    vCnt = 0
  End If
  Draw
End Sub

Private Sub Draw()
  Dim n As Long
  Dim v1 As Vector, v2 As Vector
  Cls
  If vCnt = 0 Then Exit Sub
  For n = 0 To vCnt - 2
    Circle (v(n).x, v(n).y), 3, &HFF
    If n > 0 Then
      v1 = V2Sub(v(n + 1), v(n - 1))
    Else
      v1 = V2Sub(v(n + 1), v(n))
    End If
    If n < vCnt - 2 Then
      v2 = V2Sub(v(n), v(n + 2))
    Else
      v2 = V2Sub(v(n), v(n + 1))
    End If
    DrawLine v(n), v(n + 1), v1, v2
  Next n
  Circle (v(vCnt - 1).x, v(vCnt - 1).y), 3, &HFF
End Sub

Private Sub DrawLine(v1 As Vector, v2 As Vector, dv1 As Vector, dv2 As Vector)
  Dim n As Long, s As Single, L As Single
  Dim p1 As Vector, p2 As Vector, tv1 As Vector, tv2 As Vector, tv3 As Vector
  L = V2Len(V2Sub(v2, v1))
  p1 = V2Add(v1, V2Scale(dv1, Sharpness * 0.5 * L / V2Len(dv1)))
  p2 = V2Add(v2, V2Scale(dv2, Sharpness * 0.5 * L / V2Len(dv2)))
  For n = 0 To L - 1
    s = n / L
    tv1 = V2Lerp(v1, p1, s)
    tv2 = V2Lerp(p1, p2, s)
    tv3 = V2Lerp(p2, v2, s)
    tv1 = V2Lerp(tv1, tv2, s)
    tv2 = V2Lerp(tv2, tv3, s)
    tv1 = V2Lerp(tv1, tv2, s)
    PSet (tv1.x, tv1.y), 0
  Next n
End Sub

Private Function V2Create(ByVal x As Single, ByVal y As Single) As Vector
  V2Create.x = x
  V2Create.y = y
End Function

Private Function V2Add(v1 As Vector, v2 As Vector) As Vector
  V2Add.x = v1.x + v2.x
  V2Add.y = v1.y + v2.y
End Function

Private Function V2Sub(v1 As Vector, v2 As Vector) As Vector
  V2Sub.x = v1.x - v2.x
  V2Sub.y = v1.y - v2.y
End Function

Private Function V2Scale(v As Vector, s As Single) As Vector
  V2Scale.x = v.x * s
  V2Scale.y = v.y * s
End Function

Private Function V2Lerp(v1 As Vector, v2 As Vector, s As Single) As Vector
  V2Lerp.x = v1.x * (1 - s) + v2.x * s
  V2Lerp.y = v1.y * (1 - s) + v2.y * s
End Function

Private Function V2Len(v As Vector) As Single
  V2Len = Sqr(v.x * v.x + v.y * v.y)
End Function

Private Sub Form_Load()
  HScroll1.Value = 70
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  Unload Me
End Sub

Private Sub HScroll1_Change()
  HScroll1_Scroll
End Sub

Private Sub HScroll1_Scroll()
  Sharpness = HScroll1.Value * 0.01
  Label1.Caption = " : " & Format(Sharpness, "0.000")
  Draw
End Sub
